; WLA-DX mtx tape image

; Setup for MTX512, i.e. 64Kb. Allows for basic from $4000 to $ffff

		.DEFINE FILENAME	18
		.DEFINE SYSVARS		601
		.DEFINE BASVARS		1

; Slot start = $4000 - FILENAME - SYSVARS = $3d95
; Slot size  = $c000 + FILENAME + SYSVARS + BASVARS = $c26c

.MEMORYMAP
                DEFAULTSLOT 0
                SLOT 0 START $3d95 SIZE $c26c
.ENDME

.ROMBANKMAP
                BANKSTOTAL 1
                BANKSIZE $c26c
                BANKS 1
.ENDRO

                .BANK 0 SLOT 0

                .ORGA $3d95

		.SECTION "MAIN"

;--------------------------------------------------------------------------------
; Output filename and sysvars to tape image
;--------------------------------------------------------------------------------

		; Output filename. Has to be 15 chars, right padded with spaces.
		; The zmac assembler needs loops and counters.
		.DB $ff
		.DB "VGMPLAYER      "
		.DW $f8f2

;--------------------------------------------------------------------------------
; System Variables
;--------------------------------------------------------------------------------

		; $f8f2 - Data Before SYSVARS
		.DS 22 * 16, 0
		; $fa52 - CTRBADR
		.DB $00, $f2, $f8, $02, $00, $00, $00, $00, $00, $00, $00, $0a, $f9, $02, $00, $00
		.DB $00, $00, $00, $00, $00, $22, $f9, $02, $00, $00, $00, $00, $00, $00, $00, $3a
		.DB $f9, $02, $00, $00, $00, $00, $00, $00

		.DB $01				; $fa7a - LSTPG. Number of 32kb pages -1
		.DW $c000			; $fa7b - VARNAM. Bottom of variable names (Normally $C000)
		.DW $c001			; $fa7d - VALBOT. Bottom of variable values (Normally $C001)
		.DW $c001			; $fa7f - CALCBOT. Bottom of calculator stack (Normally $C001)
		.DW $c001			; $fa81 - CALCST. Top of calculator stack (Normally $C001)
		.DW $fb4b			; $fa83 - KBDBUF. Addr of keyboard buffer (Normally $FB4B)
		.DB $00, $00, $00, $00		; $fa85 - USYNT. USER cmd word syntax bytes
		.DB $00, $c9, $c9		; $fa89 - USER. User cmd word jump sv_address
		.DB $00, $00, $00		; $fa8c - unused. 
		.DB $01				; $fa8f - IOPL. List Device
		.DB $ff				; $fa90 - REALBY. PANEL breakpoint byte
		.DB $a0				; $fa91 - KBFLAG. Key Lock statuses
                                		; (2:Numlock,5:Scroll Lock,7:capslock)
		.DW $f8f2			; $fa92 - STKLIM. Top of free space (Normally 0xF8F2)
		.DW $fb4b			; $fa94 - SYSTOP. Top of sysvars to save (Normally 0xFB4B)
		.DW $fd48			; $fa96 - SSTACK. Addr of machine stack (Z80 stack pointer)
		.DB $c9, $00, $00		; $fa98 - USERINT. Jump sv_addr used by user interrupt routine
                                		; (See INTFFF (0xFD5E))
		.DB $c9, $00, $00		; $fa9b - NODLOC. Jump sv_addr used for NODE expansion
		.DB $c9, $00, $00		; $fa9e - FEXPAND. Jump sv_addr used for PANEL expansion
		.DB $c9, $00, $00		; $faa1 - USERNOD. Jump sv_addr used for Noddy expansion
		.DW END_BAS - START_BAS + $4000	; $faa4 - NBTOP. Top of Noddy
		.DB $00				; $faa6 - NBTPG. Top of Noddy page
		.DW END_BAS - START_BAS + $4000	; $faa7 - BASTOP. Top of current Basic
		.DB $00				; $faa9 - BASTPG. Top of current Basic page
		.DW $4000			; $faaa - BASBOT. Bottom of Basic
		; $faac - BASTOP
		.DW END_BAS - START_BAS + $4000
		.DS 30, $00
		.DW END_BAS - START_BAS		; $facc - ARRTOP. Top of arrays
		.DB $00				; $face - ARRTPG. Top of arrays page
		.DW $4000			; $facf - BASELIN. 
		.DB $00				; $fad1 - BASLNP. 
		.DB $00				; $fad2 - PAGE. Current page configuration
		.DB $00				; $fad3 - CRNTPG. Current Basic page
		.DB $00				; $fad4 - PGN1. Temp variable used by BASIC
		.DB $00				; $fad5 - PGN2. Temp variable used by BASIC
		.DW END_BAS - START_BAS + $4000	; $fad6 - PGTOP. 
		.DS 105, $00			; $fad8 - GOSTACK. 
		.DW $fad8			; $fb41 - GOPTR. Addr to return to after GOSUB
		.DW $00				; $fb43 - GOSNUM. No of nexted GOSUBs
		.DB $00				; $fb45 - CTYLST. Keyboard Configuration
		.DW $4000			; $fb46 - DATAAD.Data pointer
		.DB $80				; $fb48 - DATAPG. Data pointer page
		.DW $fb54			; $fb49 - DESAVE. Addr in BASIC when saved

START_BAS:
START_LINE:	.DW END_LINE-START_LINE, 10
		.DB $c2
		.DW END_ASM-START_ASM
START_ASM:
		.INCLUDE "vgmplayer.asm"

END_ASM:	.DB $ff
END_LINE:
END_BAS:

;--------------------------------------------------------------------------------
; Basic Variables
;--------------------------------------------------------------------------------

		.DB $ff	; basvars

		.ENDS
